package java.awt;

import java.awt.geom.Point2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.ColorModel;

final class LinearGradientPaintContext extends MultipleGradientPaintContext
{
    private float dgdX;
    private float dgdY;
    private float gc;
    
    LinearGradientPaintContext(LinearGradientPaint linearGradientPaint, ColorModel colorModel, Rectangle rectangle, Rectangle2D rectangle2D, AffineTransform affineTransform, RenderingHints renderingHints, Point2D point2D, Point2D point2D2, float[] array, Color[] array2, MultipleGradientPaint.CycleMethod cycleMethod, MultipleGradientPaint.ColorSpaceType colorSpaceType) {
        super(linearGradientPaint, colorModel, rectangle, rectangle2D, affineTransform, renderingHints, array, array2, cycleMethod, colorSpaceType);
        float n = (float)point2D.getX();
        float n2 = (float)point2D.getY();
        float n3 = (float)point2D2.getX();
        float n4 = (float)point2D2.getY();
        float n5 = n3 - n;
        float n6 = n4 - n2;
        float n7 = n5 * n5 + n6 * n6;
        float n8 = n5 / n7;
        float n9 = n6 / n7;
        this.dgdX = this.a00 * n8 + this.a10 * n9;
        this.dgdY = this.a01 * n8 + this.a11 * n9;
        this.gc = (this.a02 - n) * n8 + (this.a12 - n2) * n9;
    }
    
    @Override
    protected void fillRaster(int[] array, int i, int n, int n2, int n3, int n4, int n5) {
        int n6 = i + n4;
        float n7 = this.dgdX * (float)n2 + this.gc;
        for (int j = 0; j < n5; i += n, n6 = i + n4, ++j) {
            for (float n8 = n7 + this.dgdY * (float)(n3 + j); i < n6; array[i++] = this.indexIntoGradientsArrays(n8), n8 += this.dgdX) {}
        }
    }
}
